#include "p18f4550.h"


#pragma config WDT=OFF, LVP=OFF, DEBUG=OFF, MCLRE = ON
#pragma config FOSC = INTOSCIO_EC

#include <spi.h>
#include <delays.h>
 
#define INDICATOR1 PORTDbits.RD3
#define INDICATOR2 PORTDbits.RD2



//control the CD4051 demultiplexer chip set which string
// of LED boards are being send the data
void SetChannel(unsigned char input){
	//demultiplexer address is set by D7, D6, D5
	
	PORTD = PORTD&0b00011111;
	PORTD = PORTD | (input << 5);
}
	


void main(void){


    unsigned char rcount=0; //present LED colour values
    unsigned char gcount=0;
    unsigned char bcount=0;
    
    unsigned char stage=0; //used to cycle through different colour values
    
	unsigned char i;

   	TRISD = 0; //initialize IO pins
	TRISC = 0;
	TRISB = 0;
    TRISA = 0;
    PORTD = 0;
	PORTC = 0;
	PORTB = 0;
	PORTA = 0;
	OSCTUNE = 0b00001111; 
	OSCCON  = 0b01110010;

    OpenSPI(SPI_FOSC_4, MODE_00, SMPEND); //initialize SPI


	while(1){ //repeat forever
			
		switch(stage){
		case 0:
		   rcount=255;
		   gcount=0;
		   bcount=0;
		   stage = 1;
		   INDICATOR1=1;
           INDICATOR2=0;
        
		break;
		case 1:
		   rcount=0;
		   gcount=255;
		   bcount=0;
		   stage = 2;
		   INDICATOR1=0;
           INDICATOR2=1;
		break;
		case 2:
		   rcount=0;
		   gcount=0;
		   bcount=255;
		   stage = 0;
		break;
		}
		
		
		//send the same data out of all output channels
		for(i  = 0; i < 8; i ++){
			SetChannel(i);
			
			WriteSPI(rcount); //red 1
			WriteSPI(bcount); //blue 1
			WriteSPI(gcount); //green 1
		
			WriteSPI(rcount); //red2
			WriteSPI(bcount); //blue2
			WriteSPI(gcount); //green2
		
			WriteSPI(gcount);//green3
			WriteSPI(bcount);//blue3
			WriteSPI(rcount);//red3
		
			WriteSPI(rcount); //red4
			WriteSPI(bcount); //blue4
			WriteSPI(gcount); //green4
		
			WriteSPI(rcount); //red5
			WriteSPI(bcount); //blue5
			WriteSPI(gcount); //green5
		
		
			WriteSPI(rcount); //red6
			WriteSPI(bcount); //blue6
			WriteSPI(gcount); //green6
		}
		
		stage++;
		
		Delay10KTCYx(200);

    }
}